﻿  ; Créer et enregistrer ce fichier sous le nom 'PureBasic.pb'
  ; La DLL 'PureBasic.dll' sera créée.
  ;Global Jambon.l
  Global DEBUG_Trap.a
  Global DEBUG_TrapMessage.s
  Global R_ReadZ80.b
  Global R_IN80.b
  Global R_CheckInterrupt.l
  Global SYSROM.a
  Global Bank0.a
  Global Bank1.a
  Global RAMBank_0.a
  Global RAMBank_1.a
  Global RAMBank_2.a
  Global RAMBank_3.a
  Global OUTregs.a
  Global INPRegs.a
  Global FRAMEBUFFER_X=240
  Global FRAMEBUFFER_Y=80
  Global DoubleSize=1 ; 0/1
  Global CurPos=0 
  Global AttenteEcran.q
  Global Old_3
  Global Old_4
  Global Old_2
  Global Old_1
  Global Attente_8192Hz.q
  Global Attente_64Hz.q
  Global Attente_1Hz.q
  Global Attente_SOUND.q
  Global InterruptFlags.a
  Global LeveInterruption.a
  Global Window_TickBox  
  Global GrosCompteur.l
  Global CDBit0.a
  Global CDBit1.a
  Global CDBit2.a
  Global BeforeTRAP.s
  Global Dim CDROM_data.a(3)
  
  Global Dim KBD_Matrix.a(10,2) ; (port11 1.2.4.8.10.20.40.80+port12 1.2,  port10 MSB....LSB + port12 MSB....LSB)
  Global KBD_Matrix_KeyPresssed.a ; =1 si une touche dans la matrice à été pressé. Descendu à 0 si aucune touche est pressé.
  Global KBD_Matrix_KeyPresssedTIMER.l ; Minuteur avant de 'lacher' la touche. Chaque nouvelle touche est "Gardé" appuyé jusqu'à que le minuteur expire.
  Global RequestPowerOff.a
  
  Global Dim SOUND_LPC_Buffer.a(8) ; 8 should be enough for everyone
  Global SOUND_LPC_BufferPointer.a ; Un pointeur pour le buffer
  Global SOUND_LPC_Timer.l ; Un timer avant echec de déduction du fichier audio.
  
  Global GenInterrupt_SON.a
  Global SONDejaInit.a
  Global SON_INITOK.a
  
  Global Dim SOUNDBank_DATA.a(29, 8)  ; (SoundNumber, DataPos)
  Global Dim SOUNDBank_NAME.s(29)     ; (SoundNumber)
  Global Dim SOUNDBank_CONFIDENCE.a(29) ; Niveau de confidence
  
  ; Pour la SOURIS
  
  
  Global SOURIS_SimTimer.l
  Global SOURIS_PasX.a
  
  
  Global MausX.a
  Global MausY.a
  Global MouseButton.a
  Global OLDMoumouseX.l
  Global OLDMoumouseY.l  
  
  Global UART_SENDByte.a
  Global UART_RECVByte.a
  Global UART_DataPresent.a
  Global UART_DataSend.a
  Global UART_CompteurTimerENVOI
  Global UART_CompteurRECV.a ; FIXME: Un putain de workaround pour AvaiableSerialInput qui mets 3 plombes à fonctionner correctement... l'émulation tombe par terre!
  
  Global Opcode_parsed.q ; TODO: Peut faire planter la DLL... FIXME: /!\ ATTENTION /!\
  
  Global TSimulator.a
  Global TSimulator_MACHINESTATE.a
  Global TSimulator_HandshakeBYTE.a
  Global TSimulator_CHECKSUM8.a
  
  
Global Dim GADGETPORT_10_Text(8)
Global Dim GADGET_PortTick11.l(8,8)
Global Dim GADGET_PortText10.l(12*256)

Global Dim GADGETPORT_12_Text(8)
Global Dim GADGET_PortTick12.l(8,8)
Global Dim GADGET_PortText12.l(12*256)

Procedure DoDebug(Texte$)
  DEBUG_Trap=1:DEBUG_TrapMessage=Texte$
EndProcedure

Procedure GethoMOUSEDeltaX()
  x=DesktopMouseX()
  
  ARetourner=x-OLDMoumouseX
  
  OLDMoumouseX=x
  ProcedureReturn ARetourner
EndProcedure  

Procedure GethoMOUSEDeltaY()
  y=DesktopMouseY()
  
  ARetourner=y-OLDMoumouseY
  
  OLDMoumouseY=y
  ProcedureReturn ARetourner
EndProcedure
    
Procedure PressKEY()
  KBD_Matrix_KeyPresssed=1: KBD_Matrix_KeyPresssedTIMER=ElapsedMilliseconds() 
EndProcedure

Procedure OpenWindow_TickBox(x = 0, y = 0, width = 450, height = 200)
  Window_TickBox = OpenWindow(#PB_Any, x, y, width, height, "", #PB_Window_SystemMenu)
  
  z=1
  For y=0 To 7
    For x=0 To 7
      GADGET_PortTick11(x, y) = CheckBoxGadget(#PB_Any, 10+(x*20),10+(y*20),20,20,"")
    Next
    GADGETPORT_10_Text(x) = TextGadget(#PB_Any, 10+(7*20)+20,   10+(y*20)+3,50,15,"0x"+RSet(Hex(z,#PB_Byte),2,"0"))
    z=z*2
  Next 
  GADGETPORT_10_Text(8) = TextGadget(#PB_Any, 10, 10+(8*20), 150,15,"=> Set value from port $11 KBD")
  
  Coeff=11
  z=1
  For y=0 To 7
    For x=0+Coeff To 7+Coeff
      GADGET_PortTick12(x-Coeff, y) = CheckBoxGadget(#PB_Any, 10+(x*20),10+(y*20),20,20,"")
    Next
    GADGETPORT_12_Text(x-Coeff) = TextGadget(#PB_Any, 10+((x*2)*10)+10,   10+(y*20)+3,50,15,"0x"+RSet(Hex(z,#PB_Byte),2,"0"))
    z=z*2
  Next 
  GADGETPORT_12_Text(8) = TextGadget(#PB_Any, 10+((x-Coeff)*20)+60, 10+(8*20), 150,15,"=> Set value from port $12 Extended") 

EndProcedure

Procedure Window_TickBox_Events(event)
  Select event
    Case #PB_Event_CloseWindow
      ProcedureReturn #False

    Case #PB_Event_Menu
      Select EventMenu()
      EndSelect

    Case #PB_Event_Gadget
      ; Debug Ticks... (and HEX values)

      
        
          
          
          
      Select EventGadget()
      EndSelect
  EndSelect
  ProcedureReturn #True
EndProcedure  
  
Procedure PutPixel(x,y,col.l)
  Shared DoubleSize
  
  
  ;Plot(XCoord+pix-1, YCoord, RGB(0,0,255))
  
  RealX=X*(DoubleSize+1)
  RealY=Y*(DoubleSize+1)
  Box(RealX,RealY,(DoubleSize+1), (DoubleSize+1),col)
EndProcedure

Procedure Dec2Bin(In$, pow)
   Dec=Val(In$)
      If In$<>""
         ;Select Dec
          ;  Case 0 To 255
        BinValue$ = RSet(Bin(Dec),8,"0")
        Valix = Val(Mid(BinValue$,pow,1))
        ;Debug valix
        ;Delay(100)
        ProcedureReturn valix
            ;Case 256 To 65535
            ;   ProcedureReturn RSet(Bin(Dec),16,"0")
         ;EndSelect
      EndIf
EndProcedure 

Procedure PixelConverter(PixCoord)
  Global XCoord
  Global YCoord
  Global Direction
  
  ;PixCoord = 1829

; INIT *****
ScreenBank = 0 ;(1 / 4)
PixelSlot = 1  ;(1 / 5)
PixelBank = 0  ;(1 / 6)

CurrentLine = 0 ;(0 / 19)

; 1. Calculate the ScreenBank...
If PixCoord>0
  ScreenBank=PixCoord/600
EndIf
ScreenBank+1
If ScreenBank=5
  ScreenBank=4
EndIf

; 2. Calculate the PixelBank & CurrentLine...
_TEMPPixCoord=PixCoord
If _TEMPPixCoord>0
  ;_TEMPPixCoord-1
  PixelBank=_TEMPPixCoord/5
  ;PixelBank=Mod(PixelBank, 6)
  
  CurrentLine = PixelBank/6
  If CurrentLine>0
    PixelBank=Mod(PixelBank, 6)
  EndIf
  _TEMPScreenBANK = ScreenBank
  _TEMPScreenBANK-1
  If _TEMPScreenBANK>0
    CurrentLine=Mod(CurrentLine, 20)
  EndIf
EndIf
PixelBank+1


; 3. Calculate the PixelSlot...
PixelSlot = Mod(PixCoord, 5)
PixelSlot+1

; 4. Determine reading direction...
Select PixelBank
  Case 1,3,5
    Direction = 1 ; POSITIVE [MSB......LSB] ==>
  Case 2,4,6
    Direction = 0 ; NEGATIVE [LSB......MSB] <==
EndSelect
    

; Debug "ScreenBANK:"+Str(ScreenBank)
; Debug "PixelBANK:"+Str(PixelBank)
; Debug "PixelSlot:"+Str(PixelSlot)
; Debug "CurrentLine:"+Str(CurrentLine)

; 5. Lookup table for X Position...
Select PixelBank
  Case 6,5
    X_PixelBank = 40 ;  (1*5)*8
  Case 4,3
    X_PixelBank = 120 ; (3*5)*8
  Case 2,1
    X_PixelBank = 200 ; (5*5)*8
EndSelect

; 6. Lookup tables for Reversed ScreenBank
Select ScreenBank
  Case 1
    _ScreenBank=3
  Case 2
    _ScreenBank=2
  Case 3
    _ScreenBank=1
  Case 4
    _ScreenBank=0
EndSelect
ScreenBank=_ScreenBank

PixelSlot-1

YCoord = (ScreenBank*20)+CurrentLine;+1
; Selon le sens, il y aura 8 pixel à lire (voir Direction)
If Direction=1 ; POSITIVE
  XCoord = X_PixelBank+(PixelSlot*8)
Else
  XCoord = X_PixelBank-(PixelSlot*8)
EndIf

; Debug "Regenerated Ycoord:"+Str(YCoord)
; Debug "Regenerated Xcoord:"+Str(XCoord)
; If Direction=1
;   Debug "(+8 pixels) -> 1 Byte ; "+Str(XCoord+8)
; Else
;   Debug "(-8 pixels) -> 1 Byte ; "+Str(XCoord-8)
; EndIf


EndProcedure

Procedure DoPixelScan(PixelLen)
  PixelConverter(PixelLen) ; Convertis les coordonneées
  Pow2=1
  If Direction=1
    
    For x=1 To 8 ; 8 Passages
      Colour=Point(XCoord+x-1, YCoord)
      ;Plot(XCoord+x-1, YCoord, RGB(255,0,0)) ; Patch la zone traité
      If Red(Colour)>127 And Green(Colour)>127 And Blue(Colour)>127; On considère que c'est blanc
        ResultColour=ResultColour+Pow2
        Plot(XCoord+x-1, YCoord, RGB(255,0,0))
      EndIf
      Pow2=Pow2*2
    Next
  Else
    ;NEGATIVE!!
    For x=1 To 8; Step -1 ; 8 passages
      Colour=Point(XCoord-x, YCoord)
      ;Plot(XCoord-x, YCoord, RGB(0,0,255)) ; Patch la zone traité
      If Red(Colour)>127 And Green(Colour)>127 And Blue(Colour)>127; On considère que c'est blanc
        ResultColour=ResultColour+Pow2
        Plot(XCoord-x, YCoord, RGB(0,0,255))
      EndIf
      Pow2=Pow2*2
    Next
  EndIf
  ProcedureReturn ResultColour
EndProcedure

Procedure DoPixelDraw(PixelDat)
  ; PixelDat => Donne 8 pixels (1 OCTET)
  ; Renvoie les 8 pixels à l'écran
  Shared CurPos
  Shared XCoord
  Shared YCoord
  Shared Direction
  
  For pix=1 To 8 ; LSB au MSB
    LePixel = Bool(PixelDat & 1)
    PixelDat = PixelDat / 2
    
  PixelConverter(CurPos) ; Convertis les coordonneées

  If Direction=1
    
    ;For x=1 To 8 ; 8 Passages
    ; ; ; ; ; ;       Colour=Point(XCoord+pix-1, YCoord)
     If LePixel
       ;Plot(XCoord+pix-1, YCoord, RGB(255,0,255))
       PutPixel(XCoord+pix-1, YCoord, RGB(0,0,0))
     Else
       ;Plot(XCoord+pix-1, YCoord, RGB(0,0,255))
       PutPixel(XCoord+pix-1, YCoord, RGB(200,170,170))
     EndIf
      ;Plot(XCoord+x-1, YCoord, RGB(255,0,0)) ; Patch la zone traité
;       If Red(Colour)>127 And Green(Colour)>127 And Blue(Colour)>127; On considère que c'est blanc
;         ResultColour=ResultColour+Pow2
;         Plot(XCoord+x-1, YCoord, RGB(255,0,0))
;       EndIf
;       Pow2=Pow2*2
    ;Next
   Else
     If LePixel
       PutPixel(XCoord-pix, YCoord, RGB(0,0,0))
       ;Plot(XCoord-pix, YCoord, RGB(255,0,255))
     Else
       PutPixel(XCoord-pix, YCoord, RGB(200,170,170))
       ;Plot(XCoord-pix, YCoord, RGB(0,0,255))
     EndIf
    ;NEGATIVE!!
    ;For x=1 To 8; Step -1 ; 8 passages
    ; ; ; ; ; ; ; ;       Colour=Point(XCoord-pix, YCoord)
    
    
      ;Plot(XCoord-x, YCoord, RGB(0,0,255)) ; Patch la zone traité
; ;       If Red(Colour)>127 And Green(Colour)>127 And Blue(Colour)>127; On considère que c'est blanc
; ;         ResultColour=ResultColour+Pow2
; ;         Plot(XCoord-x, YCoord, RGB(0,0,255))
; ;       EndIf
; ;       Pow2=Pow2*2
    ;Next
  EndIf

  
  
  
    
    ;PixelConverter(CurPos)
;     If LePixel
;       Plot(XCoord, YCoord, RGB(255,0,255))
;     Else
;       Plot(XCoord, YCoord, RGB(0,0,255))
;     EndIf
    
    
  Next
  
  
  
EndProcedure  
  
Procedure OuvreUneFenetre()
  ;FRAMEBUFFER_X=240
  ;FRAMEBUFFER_Y=80
  ;DoubleSize=1 ; 0/1
  ;CurPos=0
  If InitSprite() = 0 ;Or InitKeyboard() = 0 Or InitMouse() = 0
    PrintN("{INIT SPRITE} - FAIL")
  Else
    PrintN("{INIT SPRITE} - OK")
  EndIf
  
  If InitMouse()=0
    PrintN("{INIT MOUSE} - FAIL")
  Else
    PrintN("{INIT MOUSE} - OK")
  EndIf
  
  WIN_Framebuffer=OpenWindow(#PB_Any, 0, 0, FRAMEBUFFER_X+(FRAMEBUFFER_X*DoubleSize), FRAMEBUFFER_Y+(FRAMEBUFFER_Y*DoubleSize), "Hypervieur Framebuffer Z80", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If WIN_Framebuffer  
       Global FBUFFER_Image=CreateImage(#PB_Any, FRAMEBUFFER_X+(FRAMEBUFFER_X*DoubleSize), FRAMEBUFFER_Y+(FRAMEBUFFER_Y*DoubleSize), 24)
       Global FBUFFER_Gadget=ImageGadget(#PB_Any, 0, 0, FRAMEBUFFER_X+(FRAMEBUFFER_X*DoubleSize), FRAMEBUFFER_Y+(FRAMEBUFFER_Y*DoubleSize), FBUFFER_Image)
       If FBUFFER_Image
         StartDrawing(ImageOutput(FBUFFER_Image))
         ;Ellipse(70, 50, 30, 10, RGB(0,0,255))
         ;Ellipse(186, 50, 30, 10, RGB(0,0,255))
         ;LineXY(128, 80, 128, 150, RGB(255, 0, 255))
         ;RoundBox(70, 200, 110, 30, 20, 20, RGB(255, 0, 0))
         StopDrawing()
       Else
         MessageRequester("FAIL", "Shitfuk at CreateImage() => NO FRAMEBUFFER!!!")
         ;End
       EndIf
    Else
      MessageRequester("FAIL!", "Shitfuk at OpenWindow() => NO FRAMEBUFFER!!")
     ; End
  EndIf   
EndProcedure

ProcedureDLL AttachProcess(Instance) ; This is AttachProcess. The mother of init!
  Global SYSROM.a
  RequestPowerOff=0 ; On VEUX qu'il fonctionne...!
    ;MessageRequester("LALALA", "Je me lance !")
    
    ;im Jambon.l  
    ;Fromage=10
    
    
    
    
    
    UART_DataSend=1 ; INIT Stuff...
    
    OpenConsole("PBASIC Debugger...")
    If Not  ReadFile(1,"YENOROM.BIN")
      MessageRequester("FAIL!", "Fail to OPEN ROM YENOROM.BIN!")
      While(1)
        Delay(250)
      Wend
    EndIf
    
    ConsoleColor(10,12)
    PrintN("Welcome to the Yeno Compusavant Emulator!")
    PrintN("-----------------------------------------")
    PrintN("")
    PrintN("This emulator try to simulate the YENO Compusavant (1997) closest as possible ")
    PrintN("but with some quirks:")
    ConsoleColor(7,0)
    PrintN("-> CPU (z80) is handled via the excecutable. The YENO stuff inside the .dll...")
    PrintN("-> Sound chip is not supported (LPC encoding). But a pseudo simulation is ")
    PrintN("realized via comparing the bitstream played against LPC audio files.")
    PrintN("-> Video supported. (but again in a laaaazy way)")
    PrintN("-> UART transfert is fully supported.")
    PrintN("-> Kbd is supported (check F1-F9 for toying with activities)...")
    PrintN("-> Printer port is not supported.")
    PrintN("   Also : ")
    ConsoleColor(7,1)
    PrintN("DEL  - Kill the sim.")
    PrintN("End  - Simulate PowerOff key")
    PrintN("PGUP - Define CDROM bit")
    PrintN("PGDN - Enable Or Disable emulated UART file transfert")
    PrintN("Left CTRL - Simulate left click")
    ConsoleColor(7,0)
    PrintN("")
    PrintN("     Enjoy ! ~Alex")
    PrintN("")
    

    
    ;     PortCOM$=InputRequester("PBASIC Debugger.. COM PORT", "Quel port COM tu veux utiliser?", "COM20")
    Print("UART: Choose your COM port (which number)? >"):Com$=Input()
      If OpenSerialPort(42, Com$, 9600, #PB_SerialPort_NoParity, 8, 1, #PB_SerialPort_NoHandshake, 8, 8) ; Trop de buffer pour cette connerie...
        PrintN("{INIT UART "+PortCOM$+"} OK!")
      Else
        PrintN("{INIT UART "+PortCOM$+"} FAIL!")
        Com$=";:/\!!??"
      EndIf
    
;       If CreateFile(5, "C:\TESTAS\UARTDump"+Com$+".txt", #PB_File_NoBuffering)
;         WriteStringN(5, "Debut de l'enregistrement des I/O liée à l'UART : "+Com$)
;         WriteStringN(5, "Format: MAITRE{-->/<--}ESCLAVE;{Nombre d'instructions exécutés};${Octet en HEXADECIMAL}")
;         WriteStringN(5, "")
;       Else
;         PrintN("{INIT UART Debug} FAIL!")
;       EndIf
      
    
    
    
    Global Dim OUTregs.a($FF) ; Registres de sorties
    Global Dim INPregs.a($FF) ; Registres d'entrée
    ;------><8 SNIP HERE - Populate sound tables 8><--------
    
SOUNDBank_NAME(0)="ANGLAIS":SOUNDBank_DATA(0, 0)=188:SOUNDBank_DATA(0, 1)=74:SOUNDBank_DATA(0, 2)=19:SOUNDBank_DATA(0, 3)=146:SOUNDBank_DATA(0, 4)=153:SOUNDBank_DATA(0, 5)=19:SOUNDBank_DATA(0, 6)=226:SOUNDBank_DATA(0, 7)=104
SOUNDBank_NAME(1)="AUREVOIR":SOUNDBank_DATA(1, 0)=226:SOUNDBank_DATA(1, 1)=98:SOUNDBank_DATA(1, 2)=138:SOUNDBank_DATA(1, 3)=236:SOUNDBank_DATA(1, 4)=104:SOUNDBank_DATA(1, 5)=3:SOUNDBank_DATA(1, 6)=235:SOUNDBank_DATA(1, 7)=75
SOUNDBank_NAME(2)="BONJOUR":SOUNDBank_DATA(2, 0)=93:SOUNDBank_DATA(2, 1)=33:SOUNDBank_DATA(2, 2)=156:SOUNDBank_DATA(2, 3)=6:SOUNDBank_DATA(2, 4)=153:SOUNDBank_DATA(2, 5)=88:SOUNDBank_DATA(2, 6)=13:SOUNDBank_DATA(2, 7)=49
SOUNDBank_NAME(3)="CDROM":SOUNDBank_DATA(3, 0)=48:SOUNDBank_DATA(3, 1)=236:SOUNDBank_DATA(3, 2)=164:SOUNDBank_DATA(3, 3)=0:SOUNDBank_DATA(3, 4)=70:SOUNDBank_DATA(3, 5)=216:SOUNDBank_DATA(3, 6)=82:SOUNDBank_DATA(3, 7)=192
SOUNDBank_NAME(4)="CHOISIS":SOUNDBank_DATA(4, 0)=187:SOUNDBank_DATA(4, 1)=70:SOUNDBank_DATA(4, 2)=43:SOUNDBank_DATA(4, 3)=96:SOUNDBank_DATA(4, 4)=231:SOUNDBank_DATA(4, 5)=106:SOUNDBank_DATA(4, 6)=3:SOUNDBank_DATA(4, 7)=236
SOUNDBank_NAME(5)="DEUX":SOUNDBank_DATA(5, 0)=44:SOUNDBank_DATA(5, 1)=211:SOUNDBank_DATA(5, 2)=146:SOUNDBank_DATA(5, 3)=23:SOUNDBank_DATA(5, 4)=180:SOUNDBank_DATA(5, 5)=224:SOUNDBank_DATA(5, 6)=37:SOUNDBank_DATA(5, 7)=6
SOUNDBank_NAME(6)="DONNEESTRANSFERES":SOUNDBank_DATA(6, 0)=194:SOUNDBank_DATA(6, 1)=50:SOUNDBank_DATA(6, 2)=201:SOUNDBank_DATA(6, 3)=128:SOUNDBank_DATA(6, 4)=174:SOUNDBank_DATA(6, 5)=76:SOUNDBank_DATA(6, 6)=119:SOUNDBank_DATA(6, 7)=203
SOUNDBank_NAME(7)="EFFECT1":SOUNDBank_DATA(7, 0)=208:SOUNDBank_DATA(7, 1)=189:SOUNDBank_DATA(7, 2)=121:SOUNDBank_DATA(7, 3)=0:SOUNDBank_DATA(7, 4)=102:SOUNDBank_DATA(7, 5)=206:SOUNDBank_DATA(7, 6)=48:SOUNDBank_DATA(7, 7)=192
SOUNDBank_NAME(8)="EFFECT2":SOUNDBank_DATA(8, 0)=48:SOUNDBank_DATA(8, 1)=115:SOUNDBank_DATA(8, 2)=85:SOUNDBank_DATA(8, 3)=3:SOUNDBank_DATA(8, 4)=122:SOUNDBank_DATA(8, 5)=40:SOUNDBank_DATA(8, 6)=47:SOUNDBank_DATA(8, 7)=64
SOUNDBank_NAME(9)="EFFECT3":SOUNDBank_DATA(9, 0)=14:SOUNDBank_DATA(9, 1)=216:SOUNDBank_DATA(9, 2)=223:SOUNDBank_DATA(9, 3)=205:SOUNDBank_DATA(9, 4)=1:SOUNDBank_DATA(9, 5)=235:SOUNDBank_DATA(9, 6)=91:SOUNDBank_DATA(9, 7)=4
SOUNDBank_NAME(10)="FRANCAIS":SOUNDBank_DATA(10, 0)=208:SOUNDBank_DATA(10, 1)=125:SOUNDBank_DATA(10, 2)=38:SOUNDBank_DATA(10, 3)=3:SOUNDBank_DATA(10, 4)=134:SOUNDBank_DATA(10, 5)=207:SOUNDBank_DATA(10, 6)=18:SOUNDBank_DATA(10, 7)=192
SOUNDBank_NAME(11)="INFORMATIQUE":SOUNDBank_DATA(11, 0)=43:SOUNDBank_DATA(11, 1)=244:SOUNDBank_DATA(11, 2)=144:SOUNDBank_DATA(11, 3)=75:SOUNDBank_DATA(11, 4)=116:SOUNDBank_DATA(11, 5)=147:SOUNDBank_DATA(11, 6)=76:SOUNDBank_DATA(11, 7)=51
SOUNDBank_NAME(12)="INSTALLELECD":SOUNDBank_DATA(12, 0)=148:SOUNDBank_DATA(12, 1)=234:SOUNDBank_DATA(12, 2)=51:SOUNDBank_DATA(12, 3)=52:SOUNDBank_DATA(12, 4)=58:SOUNDBank_DATA(12, 5)=202:SOUNDBank_DATA(12, 6)=177:SOUNDBank_DATA(12, 7)=75
SOUNDBank_NAME(13)="JEUXDEMOTS":SOUNDBank_DATA(13, 0)=211:SOUNDBank_DATA(13, 1)=103:SOUNDBank_DATA(13, 2)=165:SOUNDBank_DATA(13, 3)=116:SOUNDBank_DATA(13, 4)=42:SOUNDBank_DATA(13, 5)=18:SOUNDBank_DATA(13, 6)=49:SOUNDBank_DATA(13, 7)=75
SOUNDBank_NAME(14)="JOUEUR":SOUNDBank_DATA(14, 0)=208:SOUNDBank_DATA(14, 1)=21:SOUNDBank_DATA(14, 2)=147:SOUNDBank_DATA(14, 3)=134:SOUNDBank_DATA(14, 4)=37:SOUNDBank_DATA(14, 5)=109:SOUNDBank_DATA(14, 6)=201:SOUNDBank_DATA(14, 7)=114
SOUNDBank_NAME(15)="MATHEMATIQUE":SOUNDBank_DATA(15, 0)=171:SOUNDBank_DATA(15, 1)=166:SOUNDBank_DATA(15, 2)=202:SOUNDBank_DATA(15, 3)=141:SOUNDBank_DATA(15, 4)=17:SOUNDBank_DATA(15, 5)=55:SOUNDBank_DATA(15, 6)=233:SOUNDBank_DATA(15, 7)=217
SOUNDBank_NAME(16)="MODE":SOUNDBank_DATA(16, 0)=154:SOUNDBank_DATA(16, 1)=154:SOUNDBank_DATA(16, 2)=20:SOUNDBank_DATA(16, 3)=24:SOUNDBank_DATA(16, 4)=175:SOUNDBank_DATA(16, 5)=148:SOUNDBank_DATA(16, 6)=108:SOUNDBank_DATA(16, 7)=26
SOUNDBank_NAME(17)="NIVEAU":SOUNDBank_DATA(17, 0)=211:SOUNDBank_DATA(17, 1)=146:SOUNDBank_DATA(17, 2)=202:SOUNDBank_DATA(17, 3)=136:SOUNDBank_DATA(17, 4)=182:SOUNDBank_DATA(17, 5)=26:SOUNDBank_DATA(17, 6)=75:SOUNDBank_DATA(17, 7)=219
SOUNDBank_NAME(18)="QUATRE":SOUNDBank_DATA(18, 0)=99:SOUNDBank_DATA(18, 1)=72:SOUNDBank_DATA(18, 2)=136:SOUNDBank_DATA(18, 3)=186:SOUNDBank_DATA(18, 4)=149:SOUNDBank_DATA(18, 5)=17:SOUNDBank_DATA(18, 6)=21:SOUNDBank_DATA(18, 7)=199
SOUNDBank_NAME(19)="QUIZ":SOUNDBank_DATA(19, 0)=1:SOUNDBank_DATA(19, 1)=49:SOUNDBank_DATA(19, 2)=87:SOUNDBank_DATA(19, 3)=49:SOUNDBank_DATA(19, 4)=32:SOUNDBank_DATA(19, 5)=199:SOUNDBank_DATA(19, 6)=76:SOUNDBank_DATA(19, 7)=39
SOUNDBank_NAME(20)="SOUSMARINCOULE":SOUNDBank_DATA(20, 0)=0:SOUNDBank_DATA(20, 1)=39:SOUNDBank_DATA(20, 2)=212:SOUNDBank_DATA(20, 3)=8:SOUNDBank_DATA(20, 4)=224:SOUNDBank_DATA(20, 5)=248:SOUNDBank_DATA(20, 6)=74:SOUNDBank_DATA(20, 7)=3
SOUNDBank_NAME(21)="STRATEGIE":SOUNDBank_DATA(21, 0)=48:SOUNDBank_DATA(21, 1)=66:SOUNDBank_DATA(21, 2)=148:SOUNDBank_DATA(21, 3)=1:SOUNDBank_DATA(21, 4)=70:SOUNDBank_DATA(21, 5)=170:SOUNDBank_DATA(21, 6)=86:SOUNDBank_DATA(21, 7)=192
SOUNDBank_NAME(22)="TOUCHE":SOUNDBank_DATA(22, 0)=17:SOUNDBank_DATA(22, 1)=65:SOUNDBank_DATA(22, 2)=71:SOUNDBank_DATA(22, 3)=169:SOUNDBank_DATA(22, 4)=250:SOUNDBank_DATA(22, 5)=220:SOUNDBank_DATA(22, 6)=64:SOUNDBank_DATA(22, 7)=68
SOUNDBank_NAME(23)="TROIS":SOUNDBank_DATA(23, 0)=141:SOUNDBank_DATA(23, 1)=102:SOUNDBank_DATA(23, 2)=51:SOUNDBank_DATA(23, 3)=160:SOUNDBank_DATA(23, 4)=176:SOUNDBank_DATA(23, 5)=92:SOUNDBank_DATA(23, 6)=1:SOUNDBank_DATA(23, 7)=36
SOUNDBank_NAME(24)="TUASHEURTEUNEMINE":SOUNDBank_DATA(24, 0)=128:SOUNDBank_DATA(24, 1)=19:SOUNDBank_DATA(24, 2)=34:SOUNDBank_DATA(24, 3)=21:SOUNDBank_DATA(24, 4)=112:SOUNDBank_DATA(24, 5)=87:SOUNDBank_DATA(24, 6)=149:SOUNDBank_DATA(24, 7)=1
SOUNDBank_NAME(25)="UN":SOUNDBank_DATA(25, 0)=125:SOUNDBank_DATA(25, 1)=74:SOUNDBank_DATA(25, 2)=11:SOUNDBank_DATA(25, 3)=139:SOUNDBank_DATA(25, 4)=171:SOUNDBank_DATA(25, 5)=48:SOUNDBank_DATA(25, 6)=207:SOUNDBank_DATA(25, 7)=162
SOUNDBank_NAME(26)="UNJEU":SOUNDBank_DATA(26, 0)=41:SOUNDBank_DATA(26, 1)=92:SOUNDBank_DATA(26, 2)=178:SOUNDBank_DATA(26, 3)=67:SOUNDBank_DATA(26, 4)=47:SOUNDBank_DATA(26, 5)=165:SOUNDBank_DATA(26, 6)=230:SOUNDBank_DATA(26, 7)=112
SOUNDBank_NAME(27)="UNMENU":SOUNDBank_DATA(27, 0)=49:SOUNDBank_DATA(27, 1)=83:SOUNDBank_DATA(27, 2)=163:SOUNDBank_DATA(27, 3)=171:SOUNDBank_DATA(27, 4)=28:SOUNDBank_DATA(27, 5)=161:SOUNDBank_DATA(27, 6)=198:SOUNDBank_DATA(27, 7)=72
SOUNDBank_NAME(28)="UNPROGRAMME":SOUNDBank_DATA(28, 0)=161:SOUNDBank_DATA(28, 1)=98:SOUNDBank_DATA(28, 2)=5:SOUNDBank_DATA(28, 3)=37:SOUNDBank_DATA(28, 4)=68:SOUNDBank_DATA(28, 5)=168:SOUNDBank_DATA(28, 6)=87:SOUNDBank_DATA(28, 7)=148

;------><8 
    
    Global Dim SYSROM.a(Lof(1)) ; La ROM complète*
    BankNum = Lof(1)/$2000 ; Renvoie le nombre de banques utilisables 
    
    
    Global Dim Bank0.a(BankNum, $2000)   ; $8000 => $9FFF
    Global Dim Bank1.a(BankNum, $2000)   ; $A000 => $BFFF
    
    Global Dim RAMBank_0.a($2000) 
    Global Dim RAMBank_1.a($2000)
    Global Dim RAMBank_2.a($2000)
    Global Dim RAMBank_3.a($2000)
    
    For x=0 To $95F
      RAMBank_2(x)=Random(255,0)
    Next 
    
    
    RAMBank_2(0)='T'
    RAMBank_2(1)='O'
    RAMBank_2(2)='X'
    RAMBank_2(3)='I'
    RAMBank_2(4)='C'
    
    RAMBank_3(0)='P'
    RAMBank_3(1)='A'
    RAMBank_3(2)='T'
    RAMBank_3(3)='O'
    RAMBank_3(4)='U'        
    
    RAMBank_3($1FFF)='L'
    RAMBank_3($1FFE)='X'
    RAMBank_3($1FFD)='X'
    
    PrintN("Find me on Cheatengine... :) RAMBank2 => TOXIC RAMBank3 => PATOU")
    ;dummy$=Input()
    
    Print("Loading ROM into MEMORY...")
    For x=0 To Lof(1)
      ;FileSeek(1, x)
      SYSROM(x) = ReadAsciiCharacter(1)
    Next
    PrintN(" DONE")
    OuvreUneFenetre()
    

    
    ;OpenWindow_TickBox()
    PrintN("Loading BANK 0 into MEMORY...")
    For x=0 To BankNum-1
      FileAddress = $8000 + (x * $2000)
      ;PrintN("DEBUG LdrBank0 ; "+Str(x))
      If x>(BankNum-1-4)
        FileAddress = ((x-(BankNum-1-4)) * $2000)
      EndIf
      ;CreateFile(2, "C:\TESTAS\BANK0_"+Str(x)+"_"+Hex(FileAddress)+"-"+Hex(FileAddress+$1FFF)+".BIN")
      ;CreateFile(2, "C:\TESTAS\IOLog.txt")
      ;CreateFile(2, "C:\TESTAS\SoundSniff.raw")
      For y=0 To $1FFF
        Bank0(x, y)=SYSROM(FileAddress+y)
        ;WriteAsciiCharacter(2, SYSROM(FileAddress+y))
      Next y
      ;CloseFile(2)
    Next x
    PrintN(" DONE")
    
    Print("Loading BANK 1 into MEMORY...")
    For x=0 To BankNum-1
      FileAddress = (x * $2000) ; Algo de base pour la bank B ($A000 - $BFFF)
      For y=0 To $1FFF
        Bank1(x, y)=SYSROM(FileAddress+y)
      Next y
    Next x
    
    
    
    CloseFile(1)
    ; Debug Menu...
    ;PressKEY(): KBD_Matrix(0, 0) | $04 : KBD_Matrix(0, 0) | $10
    
    
EndProcedure
  
Procedure DoRefreshScreen()
   StartDrawing(ImageOutput(FBUFFER_Image))
          For Curpos=0 To 2399
            DoPixelDraw(RAMBank_2(CurPos)) 
          Next CurPos
   StopDrawing() : SetGadgetState(FBUFFER_Gadget, ImageID(FBUFFER_Image)) ; Affichage  
EndProcedure
  
ProcedureDLL MaFonction() ; Initialise le système SON... Purebasic fait crasher InitSound() si il se trouve dans AttachProcess() ou autre part.... c'est de la merde!
  If Not SONDejaInit
    SON_INITOK=InitSound()
;         LoadSound(0, "C:\Users\skyrider\Desktop\paste.wav")
;     PlaySound(0, #PB_Sound_Loop)
  EndIf
EndProcedure
  
ProcedureDLL.a ReadZ80(Address.l) ; Lis un octet de la RAM
  
;     If Address=>$D702 And Address=<$D70F
;     DoDebug("DICT_Texte READ")
;   EndIf
  
;     If Address=>$38 And Address<=$66
;       PrintN("Interrupt CALL!!!")
;     EndIf
  If Address=$D356 Or Address=$D357
    ;ProcedureReturn $AA ; Bloque le timer "Autoshutdown"
  EndIf
  
  If Address=$D3E7
    DoDebug("RND Seed")
  EndIf
  
  ;TODO Le "seed" des jeux viens de {WORD} $D3E7. Si il reste fixe, c'est systématiquement la MEME QUESTION POSEE!! :D
  ;   If Address=$D3ED Or Address=$D3E9 Or Address=$D3E7; Patch antialéatoire "BASE Seed"
; ; ;   If Address=$D3E7 Or Address=$D3E
; ; ;     ProcedureReturn Random(1,0) ; Do it simple !
; ; ;   EndIf
; ; ;   If Address=$D3E8
; ; ;     ProcedureReturn $0
; ; ;   EndIf
  
  
  
    If Address=>0 And Address<=$7FFF          ; Base ROM
      R_ReadZ80 = SYSROM(Address)
    ElseIf address=>$8000 And Address<=$9FFF  ; BANK 0 (Only ROM)
      If OUTregs(2)=0 
        
        RealAddress = Address - $8000
        R_ReadZ80 = Bank0(OUTregs(1), RealAddress)
        
        ;PrintN("  PRESS ENTER... OutREGS(1)="+Str(OUTregs(1)))
        ;Dummy$=Input()
      Else
        PrintN("WARNING ; READ Out of bounds BANK 0 ($8000 - $9FFF) RealAddress:"+Hex(RealAddress)+" (1):"+Hex(OUTregs(1))+" (2):"+Hex(OUTregs(2)))
        Delay(1)
      EndIf
    ElseIf Address=>$A000 And Address<=$BFFF  ; BANK 1 (ROM / RAM)
      If OUTregs(4)=0 
        RealAddress = Address - $A000
        R_ReadZ80 = Bank1(OUTregs(3), RealAddress)
      ElseIf OUTregs(4)=$10  ; RAM Bankswitching
        RealAddress = Address - $A000
        RealRAMBank = Mod(OUTregs(3), 4)
        Select OUTregs(3)
          Case 0:  ; INVISIBLE FROM SYSTEM MEMORY
            R_ReadZ80=RAMBank_0(RealAddress)
          Case 1:  ; INVISIBLE FROM SYSTEM MEMORY
            R_ReadZ80=RAMBank_1(RealAddress)
          Case 2:  ; /!\ Visible from system's memory /!\ => $C000-$DFFF
            R_ReadZ80=RAMBank_2(RealAddress)
          Case 3:  ; /!\ Visible from system's memory /!\ => $E000-FFFF
            R_ReadZ80=RAMBank_3(RealAddress)
        EndSelect
      Else
        RealAddress = Address - $A000
        If OUTregs(3)<>Old_3 Or OUTregs(4)<>Old_4
          Old_3=OUTregs(3)
          Old_4=OUTregs(4)
          PrintN("WARNING ; READ Out of bounds BANK 1 ($A000 - $BFFF) RealAddress"+Hex(RealAddress)+" (3):"+Hex(OUTregs(3))+" (4):"+Hex(OUTregs(4)))
          Delay(1)
        EndIf
      EndIf
            
    ElseIf Address=>$C000 And Address<=$DFFF  ; RAM Area (1 / 2 ; RAMBank3)
      R_ReadZ80=RAMBank_2(Address-$C000)
    ElseIf Address=>$E000 And Address<=$FFFF  ; RAM Area (2 / 2 ; RAMBank4)
      R_ReadZ80=RAMBank_3(Address-$E000)
    EndIf
    
   ;;;;; TODO: PrintN("ReadZ80 :"+Hex(Address)+" Dat:"+Hex(R_ReadZ80, #PB_Byte))
    ;FileSeek(1, Address)
    ;R_ReadZ80=ReadAsciiCharacter(1)
    ;Delay(1)
    ProcedureReturn R_ReadZ80;
EndProcedure
  
ProcedureDLL WriteZ80(Address.l, Valeur.a) ; Ecris une valeur en RAM
  
;   If Address=>$D702 And Address=<$D70F
;     DoDebug("DICT_Texte WRITE VAL:"+Str(Valeur))
;   EndIf
  
    
    If Address=>0 And Address<=$7FFF          ; Base ROM
      ; NE FAIT RIEN ; ON EST EN ZONE ROM!
      ;R_ReadZ80 = SYSROM(Address)
    ElseIf address=>$8000 And Address<=$9FFF  ; BANK 0 (Only ROM)
      ; NE FAIT RIEN ; On EST EN ZONE ROM!
;       If OUTregs(2)=0 
;         RealAddress = Address - $8000
;         R_ReadZ80 = Bank0(OUTregs(1), RealAddress)
;       Else
;         PrintN("WARNING ; Out of bounds BANK 0 ($8000 - $9FFF) RealAddress:"+Hex(RealAddress)+" (1):"+Hex(OUTregs(1))+" (2):"+Hex(OUTregs(2)))
;       EndIf
      
    ElseIf Address=>$A000 And Address<=$BFFF  ; BANK 1 (ROM / RAM)
      If OUTregs(4)=0 
        ; NE FAIT RIEN ; ON EST EN ZONE ROM !
;         RealAddress = Address - $A000
;         R_ReadZ80 = Bank1(OUTregs(3), RealAddress)
      ElseIf OUTregs(4)=$10  ; RAM Bankswitching
        RealAddress = Address - $A000
        RealRAMBank = Mod(OUTregs(3), 4)
        Select RealRAMBank
          Case 0:  ; INVISIBLE FROM SYSTEM MEMORY
            RAMBank_0(RealAddress) = Valeur
            ;R_ReadZ80=RAMBank_0(RealAddress)
          Case 1:  ; INVISIBLE FROM SYSTEM MEMORY
            RAMBank_1(RealAddress) = Valeur
            ;R_ReadZ80=RAMBank_1(RealAddress)
          Case 2:  ; /!\ Visible from system's memory /!\ => $C000-$DFFF
            RAMBank_2(RealAddress) = Valeur
            ;R_ReadZ80=RAMBank_2(RealAddress)
          Case 3:  ; /!\ Visible from system's memory /!\ => $E000-FFFF
            RAMBank_3(RealAddress) = Valeur
            ;R_ReadZ80=RAMBank_3(RealAddress)
        EndSelect
      Else
        PrintN("WARNING ; WRITE Out of bounds BANK 1 ($A000 - $BFFF) RealAddress"+Hex(RealAddress)+" (3):"+Hex(OUTregs(3))+" (4):"+Hex(OUTregs(4)))
        Delay(1)
      EndIf
            
    ElseIf Address=>$C000 And Address<=$DFFF  ; RAM Area (1 / 2 ; RAMBank3)
                                              ;R_ReadZ80=RAMBank_2(Address-$C000)
      RAMBank_2(Address-$C000)=Valeur
    ElseIf Address=>$E000 And Address<=$FFFF  ; RAM Area (2 / 2 ; RAMBank4)
                                              ;R_ReadZ80=RAMBank_3(Address-$E000)
      RAMBank_3(Address-$E000)=Valeur
    EndIf
    
    
    
    
   ;;;;; TODO: PrintN("WriteZ80 Address:"+Hex(Address)+" Valeur:"+Hex(Valeur))
    ;Delay(1)
EndProcedure
  
ProcedureDLL OUTZ80(Port.l, Valeur.a)
  ;;;;;TODO: PrintN("OutZ80 Port:"+Hex(Port)+" Valeur:"+Hex(Valeur))
;   If port=$40 Or Port=$41 Or Port=$42 Or port=$43 Or port=$44 Or port=$45
;     PrintN("UART OUT: $"+RSet(Hex(Valeur,#PB_Byte),2,"0"))
;     DEBUG_Trap=1:DEBUG_TrapMessage="UART_OUT SYS:"+Hex(port)
;   EndIf
  
  If port=$40 ; Envoi de données
    UART_DataSend=0 ; On A PAS ENCORE ENVOYE LES DONNES!
    UART_CompteurTimerENVOI=16 ; Me semble correct comme //temps instruction avant envoi efficace des données//
    UART_SENDByte=Valeur
    INPRegs($45) & %10111111 ; On jette le byte disant qu'on a bien envoyé la donnée.
  EndIf
    
    
  
    If Port=$0B And Valeur=0 ; Power OFF
      Print("The YENO Compusavant OS has requested a shutdown. Sucide in 5...")
      For x=4 To 1 Step -1
        Delay(500)
        Print(Str(x)+"...")
      Next x
      ;The sucide command... divide by 0... original comme shutdown.. ;)
      ;Div0=0
      ; Resultat=259/Div0
      RequestPowerOff=1 ; Simply the _BEST_
    EndIf
      
    
    
;     If port=$12 And Bool((Valeur & $20) And 1)
;       PrintN("DEBUG SOurisOUIOUI$12 = "+RSet(Bin(port,#PB_Byte),8,"0")+"     135B$="+RSet(Bin(RAMBank_2($135B),#PB_Byte),8,"0"))
;     EndIf
    
    OUTregs(Port)=Valeur
    
    If Port=6 ; Reset Timer... 
      ;PrintN("Port 6 ; "+Hex(Valeur))
      INPRegs(5)=INPRegs(5) & (~Valeur)
      Select Valeur
        Case $01
          ;PrintN("INTERRUPT: Reinit MOUSE/KBD $1")
        Case $10
          Attente_1Hz=ElapsedMilliseconds()
          PrintN("Reinit 1...")
        Case $20
          Attente_64Hz=ElapsedMilliseconds()
          ;PrintN("Reinit 64...")
        Case $40
          Attente_8192Hz=ElapsedMilliseconds()
          PrintN("Reinit 8192...")
      EndSelect
    EndIf
    
    
    If Port=$0A And OUTregs($1)=5 And OUTregs($2)=0 ; Algo sonore !
      SOUND_LPC_Timer=ElapsedMilliseconds()         ; On reset le timer
;       WriteAsciiCharacter(2, Valeur)
      
      
      
      For Scan=0 To 28 ; Traite tous les sons
        If Valeur = SOUNDBank_DATA(Scan, SOUNDBank_CONFIDENCE(Scan))
          SOUNDBank_CONFIDENCE(Scan)+1 ; On incrémente de 1 la confiance envers 1 son.
          
          If SOUNDBank_CONFIDENCE(Scan)=7
            PrintN("SoundPLAY!:"+SOUNDBank_NAME(Scan))
            SOUNDBank_CONFIDENCE(Scan)=0
            If IsSound(0)
              FreeSound(0)
            EndIf
            If LoadSound(0, "Audio\WAV\"+SOUNDBank_NAME(Scan)+".wav")
              PlaySound(0)
            EndIf
          EndIf
        Else
          SOUNDBank_CONFIDENCE(Scan)=0 ; On reviens à 0 si on est pas confiant...
        EndIf
      Next
    EndIf
    

    
    ;WriteStringN(2, "OutZ80 Port:"+Hex(Port)+" Valeur:"+Hex(Valeur))
    
    For x=1 To 4  ; Patch pour le BANKSwitching !!
      INPRegs(x) = OUTregs(x)
    Next x
    
    
    INPRegs($7)=OUTregs($7)
    INPRegs($40)=OUTregs($40) ; LOOBACK Test!
    ;Delay(1)
EndProcedure
  
ProcedureDLL.a INZ80(Port.l)
;   If port=$40 Or Port=$41 Or Port=$42 Or port=$43 Or port=$44 Or port=$45
;     PrintN("UART IN ")
;     DEBUG_Trap=1:DEBUG_TrapMessage="UART_IN SYS:"+Hex(port)
;   EndIf
  R_IN80=INPRegs(Port) ; Si le port n'est pas mentionné
  
  
  ;FIXME
  If Port=$40 ; Réception des données via l'UART
    R_IN80=UART_RECVByte
    INPRegs(Port)=UART_RECVByte
    UART_DataPresent=0 ; Descendre le drapeau data présent si il viens d'être lu... "question de principe" LAWL
    INPRegs($45) & %11111110 ; On a vu la donnée, on redescend le drapeau de status
  EndIf
    
  
  
  
    ; Algo de translation vers clavier
    ; L'algo du COMPUSAVANT est assès bizzare... ;
    ; Les données provenant du clavier sont lues sur le port $10 _ET_ le port $12
    ; Mais pour sélectionner les colonnes, on utilise les ports $11 _ET $12(UNIQUEMENT b0 et b1)
    ; Par conséquent, le compusavant va :
    ; - Ecrire $FF dans le port $11 ET ecrire b0=1& b1=1 vers le port $12
    ; - Lire $10 et $12
    ; - Si l'un de ces ports <> 0 C.A.D que une touche est pressé. 
    ; Par conséquent, le COMPUSAVANT va scanner la matrice du clavier. : 
    ; - Ecrire $1 vers le port $11 + Lire $10 et $12
    ; - Ecrire $2 vers le port $11 + Lire $10 et $12
    ; - Ecrire $4 vers le port $11 + Lire $10 et $12
    ; - Ecrire $8 vers le port $11 + Lire $10 et $12
    ; - Ecrire $10 vers le port $11 + Lire $10 et $12
    ; - Ecrire $20 vers le port $11 + Lire $10 et $12
    ; - Ecrire $40 vers le port $11 + Lire $10 et $12
    ; - Ecrire $80 vers le port $11 + Lire $10 et $12
    ; - Ecrire 0 vers port $11 ET Ecrire b0=1&b1=0 vers le port $12 + Lire $10 et $12
    ; - Ecrire 0 vers port $11 ET Ecrire b0=0&b1=1 vers le port $12 + Lire $10 et $12
    
    ;... et la routine est terminé! 

    
  If Port=$10 ; Lecture du port CLAVIER (port $10)
    Select OUTRegs($11)
      Case $01
        R_IN80 = KBD_Matrix(0,0) ; $1  $10
      Case $02
        R_IN80 = KBD_Matrix(1,0) ; $2  $10
      Case $04
        R_IN80 = KBD_Matrix(2,0) ; $4  $10
      Case $08
        R_IN80 = KBD_Matrix(3,0) ; $8  $10
      Case $10
        R_IN80 = KBD_Matrix(4,0) ; $10 $10
      Case $20
        R_IN80 = KBD_Matrix(5,0) ; $20 $10
      Case $40
        R_IN80 = KBD_Matrix(6,0) ; $40 $10
      Case $80
        R_IN80 = KBD_Matrix(7,0) ; $80 $10
      Case $00 ; $11=0 => On regarde le port $12
        LaValeur = OUTregs($12)
        Var0=Bool((LaValeur & $1) And 1)
        Var1=Bool((LaValeur & $2) And 1)
          
        If Var0=0 And Var1=0  ; Aucune ligne sélectionné...On ne revoie en fait rien...
          R_IN80 = 0          
        ElseIf Var0=1 And Var1=0 ; $1
          R_IN80 = KBD_Matrix(8,0)   ;$1 $12
        ElseIf Var0=0 And Var1=1 ; $2
          R_IN80 = KBD_Matrix(9,0)   ;$2 $12
        ElseIf Var0=1 And Var1=1 ; $3 SCAN ? 
          If KBD_Matrix_KeyPresssed=1 ; Si une touche à été pressé...
            R_IN80=$FC                ; On revoie que "des touches on étés pressés"
          Else
            R_IN80=0
          EndIf
        EndIf
        
        
        ; TODO : /!\ ARCHTUNG MINEN /!\ 
        If OUTregs($12)=$10 ; Lecture du statut CDROM
                            ; | 20
                            ; | 40
                            ; | 80
               ;R_IN80=0 
               If CDBit0=0
                 R_IN80 + $40       ;$80
               EndIf
               If CDBit1=0
                 R_IN80 + $20   ;$40
               EndIf
               If CDBit2=0
                 R_IN80 + $80    ;$40   ;$20
               EndIf
        EndIf
       ; TODO : /!\ ARCHTUNG MINEN /!\    
          
      Case $FF ; Scan de la matrice
          If KBD_Matrix_KeyPresssed=1 ; Si une touche à été pressé...
            R_IN80=$FC                ; On revoie que "des touches on étés pressés"
          Else
            R_IN80=0
          EndIf
      Default:
        PrintN("Read not supported $10: "+Hex(OUTregs($11)))
    EndSelect
    
    
    
;     R_IN80 | $03 ; Patch SOURIS olol
;     If MouseButton=1
;       R_IN80 & %11111101
;     EndIf
    
  EndIf
  If Port=$12 ; Lecture du port CLAVIER (port $12)
    Select OUTRegs($11)
      Case $01
        R_IN80 = KBD_Matrix(0,1) ; $1  $10
      Case $02
        R_IN80 = KBD_Matrix(1,1) ; $2  $10
      Case $04
        R_IN80 = KBD_Matrix(2,1) ; $4  $10
      Case $08
        R_IN80 = KBD_Matrix(3,1) ; $8  $10
      Case $10
        R_IN80 = KBD_Matrix(4,1) ; $10 $10
      Case $20
        R_IN80 = KBD_Matrix(5,1) ; $20 $10
      Case $40
        R_IN80 = KBD_Matrix(6,1) ; $40 $10
      Case $80
        R_IN80 = KBD_Matrix(7,1) ; $80 $10
      Case $00 ; $11=0 => On regarde le port $12
        LaValeur = OUTregs($12)
        Var0=Bool((LaValeur & $1) And 1)
        Var1=Bool((LaValeur & $2) And 1)
        Var2=Bool((LaValeur & $20) And 1)
        
        If Var0=0 And Var1=0  ; Aucune ligne sélectionné...On ne revoie en fait rien...
          R_IN80 = 0          
        ElseIf Var0=1 And Var1=0 ; $1
          R_IN80 = KBD_Matrix(8,1)   ;$1 $12
        ElseIf Var0=0 And Var1=1 ; $2
          R_IN80 = KBD_Matrix(9,1)   ;$2 $12
        ElseIf Var0=1 And Var1=1 ; $3 SCAN ? 
          If KBD_Matrix_KeyPresssed=1 ; Si une touche à été pressé...
            R_IN80=$FF                ; On revoie que "des touches on étés pressés"
          Else
            R_IN80=0
          EndIf
        EndIf

        
      Case $FF ; Scan de la matrice
          If KBD_Matrix_KeyPresssed=1 ; Si une touche à été pressé...
            R_IN80=$FF                ; On revoie que "des touches on étés pressés"
          Else
            R_IN80=0
          EndIf
      Default:
        PrintN("Read not supported $12: "+Hex(OUTregs($11)))
    EndSelect
  EndIf  
    

    
    
  If Port=7 ; Le port $7 est un port virtuel pour la souris/clavier
            ; Il déclanche une interruption {si la SOURIS est bougé} si B0 = 0
    R_IN80=INPRegs(Port) ; Si le port n'est pas mentionné
    ;Hormis ça, j'en ai rien a foutre de ce port...!
  EndIf
    
    
    
    
  ;;R_IN80=0;
  ;WriteStringN(2, "In $"+RSet(Hex(port,#PB_Byte), 2, "0")+"  Valeur $"+RSet(Hex(R_IN80,#PB_Byte), 2, "0"))
  ProcedureReturn R_IN80
EndProcedure
  

Procedure TransfertSimulator()
  ;CaMarchePas("!!!)
  ; FIXME : Cette fonction est à retravailler; les events(), les Envois/Réceptions.... ce n'est pas utilisable dans l'état
  
  
  ;MACHINESTATE : 
  ; 0 - Do nothing
  ; 1 - Send handshake
  ; 2 - Read returned handshake
  ; 3 - Send bytes
  
  
  If IsFile(6) And TSimulator=1 And TSimulator_MACHINESTATE<>0
    Select TSimulator_MACHINESTATE
      Case 1 ; Envoie l'handshake au simulateur
        UART_RECVByte=TSimulator_HandshakeBYTE
        UART_DataPresent=1
        ; Switching Mode => 1
        TSimulator_MACHINESTATE=2
        PrintN("TSim : Send handshake...")
        INPRegs($45) | $1 ; On a des données à lire !
      Case 2 ; Attends l'handshake de l'émulateur...
        If UART_DataSend=0 
          UART_DataSend=1                                ; Pour dire qu'on l'a fait!
          INPRegs($45) | $40                             ; On a bien envoyé la donnée!
          
          If UART_SENDByte=TSimulator_HandshakeBYTE
            PrintN("TSim : Correct handshake, proceeding to sending bytes...")
            ;Change Mode => 2
            TSimulator_MACHINESTATE=3
          Else
            PrintN("TSim : BAD HANDSHAKE $"+Hex(UART_SENDByte))
            TSimulator=0
            TSimulator_MACHINESTATE=0
            CloseFile(6)
          EndIf
        EndIf
      Case 3 ; Envoi des données a l'émulateur...
        If UART_DataPresent=0 ; Fonction bloquante permettant le temps à l'émulateur de lire la donnée.
          If Not Eof(6)
            UART_RECVByte=ReadAsciiCharacter(6)
            TSimulator_CHECKSUM8+UART_RECVByte ; Génération du checksum... (OBLIGATOIRE)
            UART_DataPresent=1
            INPRegs($45) | $1 ; On a des données à lire !
            ;PrintN("TSim FileSeek="+Str(Loc(6)))
            ;Delay(10)
            ; "transfert en cours olol"
          Else
            ;FIN DU FICHIER
            PrintN("TSim : END OF FILE! Thank you!")
            UART_RECVByte=TSimulator_CHECKSUM8 ; Renvoie le checksum du flux de données             
            UART_DataPresent=1
            INPRegs($45) | $1 ; On a des données à lire !
            CloseFile(6)
            TSimulator=0
            TSimulator_MACHINESTATE=0
          EndIf
        EndIf
      EndSelect
  EndIf
  
EndProcedure


ProcedureDLL.u CheckINTERRUPTZ80(AF.l, BC.l, DE.l, HL.l, IX.l, IY.l, PC.l, SP.l)
    ;;;;;TODO:PrintN("CheckINTERRUPTZ80 AF:"+Hex(AF)+" BC:"+Hex(BC)+" DE:"+Hex(DE)+" HL:"+Hex(HL)+" IX:"+Hex(IX)+" IY:"+Hex(IY)+" PC:"+Hex(PC)+" SP:"+Hex(SP))
  
  
  
;   If PC=$55C2
;    ; BC=$9864 ; Does SOME SHEEEEIIIT!
;     DoDebug("Message look BC")
;   EndIf
  
  
  Opcode_parsed+1 ; Peut faire planter la DLL!! FIXME: /!\ /!\
  
  
  If DEBUG_Trap=1
    ConsoleColor(1, $E)
    ;PrintN("DEBUG Trap! : '"+DEBUG_TrapMessage+"' PC: $"+RSet(Hex(PC,#PB_Word),4,"0"))
    PrintN("DEBUG Trap! : '"+DEBUG_TrapMessage+"'"+" AF=$"+RSet(Hex(AF, #PB_Word),4,"0")+" BC=$"+RSet(Hex(BC, #PB_Word),4,"0")+" DE=$"+RSet(Hex(DE, #PB_Word),4,"0")+" HL=$"+RSet(Hex(HL, #PB_Word),4,"0")+" IX=$"+RSet(Hex(IX, #PB_Word),4,"0")+" IY=$"+RSet(Hex(IY, #PB_Word),4,"0")+" PC: $"+RSet(Hex(PC,#PB_Word),4,"0")+" Bank$8000: (1):$"+RSet(Hex(OUTRegs(1), #PB_Byte), 2, "0")+" (2):$"+RSet(Hex(OUTRegs(2), #PB_Byte), 2, "0")+" Bank$A000: (3):$"+RSet(Hex(OUTRegs(3), #PB_Byte), 2, "0")+" (4):$"+RSet(Hex(OUTRegs(4), #PB_Byte), 2, "0"))                                     
    ConsoleColor(7, 0)
    
    If OpenFile(4, "DebugModule.txt", #PB_File_Append)
      WriteStringN(4,"DEBUG Trap! : '"+DEBUG_TrapMessage+"'"+" AF=$"+RSet(Hex(AF, #PB_Word),4,"0")+" BC=$"+RSet(Hex(BC, #PB_Word),4,"0")+" DE=$"+RSet(Hex(DE, #PB_Word),4,"0")+" HL=$"+RSet(Hex(HL, #PB_Word),4,"0")+" IX=$"+RSet(Hex(IX, #PB_Word),4,"0")+" IY=$"+RSet(Hex(IY, #PB_Word),4,"0")+" PC: $"+RSet(Hex(PC,#PB_Word),4,"0")+" Bank$8000: (1):$"+RSet(Hex(OUTRegs(1), #PB_Byte), 2, "0")+" (2):$"+RSet(Hex(OUTRegs(2), #PB_Byte), 2, "0")+" Bank$A000: (3):$"+RSet(Hex(OUTRegs(3), #PB_Byte), 2, "0")+" (4):$"+RSet(Hex(OUTRegs(4), #PB_Byte), 2, "0"))                                     
      WriteStringN(4,BeforeTRAP)
      CloseFile(4)
    EndIf
    
    DEBUG_Trap=0
    DEBUG_TrapMessage=""
  EndIf
  
;   If IsFile(6) ; Dbg UART TRACE
;     If Loc(6)=2 Or Loc(6)=3
;       If PC>$0A000
;       DEBUG_Trap=1:DEBUG_TrapMessage="UARTdbg AF=$"+RSet(Hex(AF, #PB_Word),4,"0")+" BC=$"+RSet(Hex(BC, #PB_Word),4,"0")+" DE=$"+RSet(Hex(DE, #PB_Word),4,"0")+" HL=$"+RSet(Hex(HL, #PB_Word),4,"0")+" IX=$"+RSet(Hex(IX, #PB_Word),4,"0")+" IY=$"+RSet(Hex(IY, #PB_Word),4,"0")
;       DEBUG_TrapMessage+" LOC="+Str(Loc(6))
;       EndIf
;     EndIf
;   EndIf
  
  
  If IsSerialPort(42) And TSimulator=0
    ; Partie UART (Lecture)
    If UART_CompteurRECV=200
      If AvailableSerialPortInput(42)
        If UART_DataPresent=1
          DEBUG_Trap=1:DEBUG_TrapMessage="UART_RECV Buffer_overrun!!"
        EndIf
        *Buffy=AllocateMemory(1) ; Sérieux ? Faites chier les gars....
        ReadSerialPortData(42, *Buffy, 1)
        UART_RECVByte=PeekA(*Buffy)
        FreeMemory(*Buffy)
        UART_DataPresent=1
;         If UART_RECVByte=>32 And UART_RECVByte<=126
;           WriteStringN(5,"(RECV) MAITRE <-- Esclave;"+Str(Opcode_parsed)+";$"+RSet(Hex(UART_RECVByte, #PB_Byte), 2, "0")+";"+Chr(UART_RECVByte))
;         Else
;           WriteStringN(5,"(RECV) MAITRE <-- Esclave;"+Str(Opcode_parsed)+";$"+RSet(Hex(UART_RECVByte, #PB_Byte), 2, "0"))
;         EndIf
        INPRegs($45) | $1 ; On a des données à lire !
      EndIf
    EndIf
    
    
    ; Partie UART (Ecriture)
    If UART_DataSend=0 And UART_CompteurTimerENVOI=0 ; Des données sont à envoyer... !
      *Buffy=AllocateMemory(1)                          ; Sérieux ? Faites chier les gars....
      PokeA(*Buffy, UART_SENDByte)
      WriteSerialPortData(42, *Buffy, 1)
      FreeMemory(*Buffy)
      UART_DataSend=1 ; On a bien envoyé les données!
;       If UART_SENDByte=>32 And UART_SENDByte<=126
;         WriteStringN(5,"(SEND) Maitre --> ESCLAVE;"+Str(Opcode_parsed)+";$"+RSet(Hex(UART_SENDByte, #PB_Byte), 2, "0")+";"+Chr(UART_SENDByte))
;       Else
;         WriteStringN(5,"(SEND) Maitre --> ESCLAVE;"+Str(Opcode_parsed)+";$"+RSet(Hex(UART_SENDByte, #PB_Byte), 2, "0"))
;       EndIf
      INPRegs($45) | $40 ; On a bien envoyé la donnée!
    EndIf
      
    If UART_CompteurTimerENVOI>0 ; On a une données en cours d'envoi...
      UART_CompteurTimerENVOI-1
      INPRegs($45) & %10111111 ; On jette le byte disant qu'on a bien envoyé la donnée.
    EndIf
    
    UART_CompteurRECV+1
  EndIf
  If TSimulator=1   ; Exécute le TransferSimulator....
    TransfertSimulator() ; Exécute la routine TSim...
  EndIf
    
    
    
    
  
  
  
    Touche=0
    
     ; Affichage du FRAMEBUFFER à l'écran
     If (AttenteEcran+15)<ElapsedMilliseconds()
       AttenteEcran=ElapsedMilliseconds()
       DoRefreshScreen()
       ;PrintN("CheckINTERRUPTZ80 AF:"+Hex(AF)+" BC:"+Hex(BC)+" DE:"+Hex(DE)+" HL:"+Hex(HL)+" IX:"+Hex(IX)+" IY:"+Hex(IY)+" PC:"+Hex(PC)+" SP:"+Hex(SP))
     
     KeyPressed$=Inkey()
     Touche=RawKey()
      
       
     EndIf 
     
     ;Traitement des événement "touches" appuyés
     If ((KBD_Matrix_KeyPresssedTIMER+100)<ElapsedMilliseconds()) And KBD_Matrix_KeyPresssed=1 ; 100 MSec est le temps MAX
       ;PrintN("TOUCHE Relaché")
       KBD_Matrix_KeyPresssed=0    ; Plus aucune touche n'est pressé.
       For x=0 To 9  ; Efface TOUTE la matrice
         KBD_Matrix(x,0)=0
         KBD_Matrix(x,1)=0
       Next x  
     EndIf
     

     
     ;Traitement des événement sonores...
     
     ;L'algo de lecture des sons LPC : 
     ;Dans OutZ80, j'intercepte l'écriture vers le port $0A tout en vérifiant que le bank switching correspond à la routine sonore ([1]=5 [2]=0)
     ; Si c'est le cas : 
     ;  - Je reset le timer "de déduction" des sons
     ;  
     
     
     
     If (((SOUND_LPC_Timer+100)<ElapsedMilliseconds()) Or SOUND_LPC_BufferPointer=7) And SOUND_LPC_BufferPointer<>0; 
       PrintN("EVENT SON ; Len BufferPointer:"+Str(SOUND_LPC_BufferPointer))
       SOUND_LPC_BufferPointer=0 ; On reset le pointeur... TOUJOURS! (ça nous indique que si BufferPointer=0 c'est JUSTE un bruitage genre "beep"  
     EndIf
     
     
     If (Attente_64Hz+16)<ElapsedMilliseconds() ;GenTimer 64Hz

       Attente_64Hz=ElapsedMilliseconds()
       INPRegs(5)=INPRegs(5) | $20 ; Lève le drapeau pour le timer 64 Hz
       LeveInterruption=1          ; Lève une interruption système pour le timer
       
       
       ; Getho Mouse ;)
       MausX=GethoMOUSEDeltaX()
       MausY=GethoMOUSEDeltaY()        
       RAMBank_2($135D)=MausX
       RAMBank_2($135E)=MausY
       
;          RAMBank_2($1374)=Random($EE,1)
       
     EndIf        
     
     
     If (Attente_SOUND+5)<ElapsedMilliseconds() ; Cet interruption, c'est la puce audio qui la génère... FIXME:fait chier!
       Attente_SOUND=ElapsedMilliseconds()
       INPRegs(5)=INPRegs(5) | $80; ;
       LeveInterruption=1         ; 
     EndIf
     
;      If (SOURIS_SimTimer+500)<ElapsedMilliseconds() And 1=0
;        SOURIS_SimTimer=ElapsedMilliseconds()
;        SOURIS_PasX+1 ;0 => 3 (4 pas)
;        If SOURIS_PasX=4
;          SOURIS_PasX=0
;        EndIf
; ;        If (INPRegs($7) & %00000001)=0
; ;          PrintN("EVENT GENMouse : "+Str(SOURIS_PasX))
; ;          ;RAMBank_2($135D)+1 ;FIXME C'est un test :DXX
; ;          ;RAMBank_2($135E)+1 ; YYY
; ;          INPRegs(5)=INPRegs(5) | $01; ; Lève le drapeau pour le timer 1 Hz
; ;          LeveInterruption=1         ; Lève une interruption système pour le timer
; ;        Else
; ;          PrintN("GENMouse: Forbidden!")
; ;        EndIf
;      EndIf
     
     

  

  
;     If (SOURIS_SimTimer+100)<ElapsedMilliseconds() And MouseButton=1
;       ;SOURIS_SimTimer=ElapsedMilliseconds()
;       MouseButton=0
;       ;PrintN("Clique relaché")
;    EndIf
;      
;    If MouseButton=1
;      
;      KBD_Matrix(1, 1)|$08
;      KBD_Matrix_KeyPresssed=1
;    Else
;      KBD_Matrix(1, 1)=0
;      
;    EndIf  
     
     If LeveInterruption=1 And INPRegs(5)<>0
       R_CheckInterrupt=1;$38
       LeveInterruption=0
       ;PrintN("Pas sage!")
     Else
       R_CheckInterrupt=0;$FFFF ; Continue l'emulation...
     EndIf
     
    ; dummy$=Inkey()
    ; Touche=RawKey()
     
     Select Touche
         
       Case 35 ; FIN
               ;MessageRequester("Coucou!", "C'est un bel event que nous avons là !")
         PrintN("USERREQUEST - Poweroff...")
         PressKEY(): KBD_Matrix(1, 0) | $20
       Case 46 ; SUPPR
         PrintN("Emergency shutdown - CRAM")
         PrintN("/!\ TRAP - TRAP - TRAP - TRAP /!\")
         RequestPowerOff=1
       Case 33 ; PageUP
         CDBits$=InputRequester("CDROM Changer","Tape les 3 bits du CDROM que tu veux... ex:010","111")
         CDBit0=Val(Mid(CDBits$,1,1)):Print("CDROM BIT: "+Str(CDBit0))
         CDBit1=Val(Mid(CDBits$,2,1)):Print("  CDROM BIT: "+Str(CDBit1))
         CDBit2=Val(Mid(CDBits$,3,1)):PrintN("  CDROM BIT: "+Str(CDBit2))
       Case 34 ; PageDOWN
         If TSimulator<>0 
           TSimulator=0
           TSimulator_MACHINESTATE=0
           If IsFile(6)
             CloseFile(6)
           EndIf
           PrintN("TSim : Shutdown")
         Else
           Print("TransfertSimulator - trying to open TSim.bin...")
           If Not OpenFile(6, "TSim.bin", #PB_File_SharedRead)
             PrintN("... and the open FAILED!")
             TSimulator=0
             TSimulator_MACHINESTATE=0 ; OFF
           Else
             PrintN("OK !")
             Print("Please type the HEXADECIMAL value for the handshake ($40 => $43):$")
             TSimulator_HandshakeBYTE=Val("$"+Input())
             ;TSimulator_HandshakeBYTE=$40
             If TSimulator_HandshakeBYTE=0
               TSimulator_HandshakeBYTE=$40
             endif
             ;PrintN(" = $"+Hex(TSimulator_HandshakeBYTE))
             PrintN("TSim : LISTEN => $"+Hex(TSimulator_HandshakeBYTE))
             TSimulator_MACHINESTATE=1 ; OK and LISTEN
             TSimulator=1
           EndIf
         EndIf
       Case 38 ; Touche HAUT.  (pour ($11)=$20 => ($12)=|$08
         PressKEY(): KBD_Matrix(5, 1) | $08
       Case 40 ; Touche BAS.  (pour ($12)=$01 => ($12)=|$08
         PressKEY(): KBD_Matrix(8, 1) | $08             
       Case 37 ; Touche GAUCHE.  (pour ($11)=$40 => ($12)=|$04
         PressKEY() : KBD_Matrix(6, 1) | $04               
       Case 39 ; Touche DROITE.  (pour ($11)=$80 => ($12)=|$08
         PressKEY() : KBD_Matrix(7, 1) | $08  
         
       Case 13 ; Touche ENTER.  (pour ($11)=$40 => ($12)=|$08
         PressKEY() : KBD_Matrix(6, 1) | $08              
       Case 27 ; Touche ESCAPE.  (pour ($11)=$02 => ($10)=|$04
         PressKEY(): KBD_Matrix(1, 0) | $04  
         
       Case 112 ; Touche F1-FRANCAIS  
         PressKEY(): KBD_Matrix(2, 0) | $08  
       Case 113 ; Touche F2-MATHEMATIQUES  
         PressKEY(): KBD_Matrix(1, 0) | $10               
       Case 114 ; Touche F3-ANGLAIS  
         PressKEY(): KBD_Matrix(2, 0) | $10 
       Case 115 ; Touche F4-JEUX_DE_MOTS  
         PressKEY(): KBD_Matrix(2, 0) | $20       
       Case 116 ; Touche F5-QUIZ  
         PressKEY(): KBD_Matrix(1, 0) | $40  
       Case 117 ; Touche F6-STRATEGIE  
         PressKEY(): KBD_Matrix(2, 0) | $40               
       Case 118 ; Touche F7-INFORMATIQUE  
         PressKEY(): KBD_Matrix(2, 0) | $80 
       Case 119 ; Touche F8-CDROM  
         PressKEY(): KBD_Matrix(1, 0) | $80     
         
         
         ; Chiffres de 0 à 9
       Case 48, 96
         PressKEY(): KBD_Matrix(4, 0) | $80
       Case 49, 97
         PressKEY(): KBD_Matrix(3, 0) | $04
       Case 50, 98
         PressKEY(): KBD_Matrix(4, 0) | $08
       Case 51, 99
         PressKEY(): KBD_Matrix(3, 0) | $08
       Case 52, 100
         PressKEY(): KBD_Matrix(4, 0) | $10
       Case 53, 101
         PressKEY(): KBD_Matrix(3, 0) | $10
       Case 54, 102
         PressKEY(): KBD_Matrix(4, 0) | $20
       Case 55, 103
         PressKEY(): KBD_Matrix(3, 0) | $20
       Case 56, 104
         PressKEY(): KBD_Matrix(4, 0) | $40
       Case 57, 105
         PressKEY(): KBD_Matrix(3, 0) | $40
         
         ; Alphabet complet (A=>Z)
       Case 65
         PressKEY(): KBD_Matrix(4, 0) | $04
       Case 66
         PressKEY(): KBD_Matrix(8, 0) | $20
       Case 67
         PressKEY(): KBD_Matrix(8, 0) | $10
       Case 68
         PressKEY(): KBD_Matrix(0, 0) | $10
       Case 69
         PressKEY(): KBD_Matrix(6, 0) | $08
       Case 70
         PressKEY(): KBD_Matrix(7, 0) | $10
       Case 71
         PressKEY(): KBD_Matrix(0, 0) | $20
       Case 72
         PressKEY(): KBD_Matrix(7, 0) | $20
       Case 73
         PressKEY(): KBD_Matrix(5, 0) | $40
       Case 74
         PressKEY(): KBD_Matrix(0, 0) | $40
       Case 75
         PressKEY(): KBD_Matrix(7, 0) | $40
       Case 76
         PressKEY(): KBD_Matrix(0, 0) | $80
       Case 77
         PressKEY(): KBD_Matrix(7, 0) | $80
       Case 78
         PressKEY(): KBD_Matrix(9, 0) | $20
       Case 79
         PressKEY(): KBD_Matrix(6, 0) | $40
       Case 80
         PressKEY(): KBD_Matrix(5, 0) | $80
       Case 81
         PressKEY(): KBD_Matrix(6, 0) | $04
       Case 82
         PressKEY(): KBD_Matrix(5, 0) | $10
       Case 83
         PressKEY(): KBD_Matrix(7, 0) | $08
       Case 84
         PressKEY(): KBD_Matrix(6, 0) | $10
       Case 85
         PressKEY(): KBD_Matrix(6, 0) | $20
       Case 86
         PressKEY(): KBD_Matrix(9, 0) | $10
       Case 87
         PressKEY(): KBD_Matrix(0, 0) | $08
       Case 88
         PressKEY(): KBD_Matrix(8, 0) | $08
       Case 89
         PressKEY(): KBD_Matrix(5, 0) | $20
       Case 90
         PressKEY(): KBD_Matrix(5, 0) | $08
         
       Case 20 ; CAPS LOCK
         PressKEY(): KBD_Matrix(5, 0) | $04
       Case 16 ; SHIFT
         PressKEY(): KBD_Matrix(0, 0) | $04
         
       Case 32 ; Espace
         PressKEY(): KBD_Matrix(9, 0) | $08
         
       Case 8
         PressKEY(): KBD_Matrix(4, 1) | $08
         
       Case 17 ; Click GAUCHE sur CTRL
         PressKEY(): KBD_Matrix(1, 1) | $08
        ; DesktopMouseX()
        ; MouseButton=1:SOURIS_SimTimer=ElapsedMilliseconds()
         
       ;Default:
         ;PrintN("KBD Event : "+Str(512-Touche))
     EndSelect     

     

     
     
     
     
     Event = WindowEvent()
      Select Event
      
        Case #PB_Event_Menu
          Touche=EventMenu()

; Fichier YENO_KBD_Fait.csv
; TODO : Begin. (Enleve ';' à chaque debut de ligne pour avoir la matrice du clavier)
;     ;;;;;;;;;;Valeur de $11;KBD_Matrix
;     ;;L;J;G;D;W;Left SHIFT;;;$01;0, 0
;     ;Menu « activité »;CDROM;Quiz;Arrêt;Mathématique;« $09 »;ESCAPE;;;$02;1, 0
;     ;Système;INFORMATIQUE;STRATEGIE;JeuDeMot;Anglais;Français;Imprimer;;;$04;2, 0
;     ;Lecteur « CDROM »;B eszett ;9 ç;7 è;5 ?;"3 """;1 &;;;$08;3, 0
;     ;;0 à;8 $;6 _;4 ~;2 é;A;;;$10;4, 0
;     ;;P;i;Y;R;Z;Caps LOCK;;;$20;5, 0
;     ;;¨ ^;O;U;T;E;Q;;;$40;6, 0
;     ;;M;K;H;F;S;<;;;$80;7, 0
;     ;Valeur lue de $10;$80;$40;$20;$10;$08;$04;$02;$01;;
;     ;;;;;;;;;;Valeur de $11;
;     ;;;;;;RightSHIFT;!;;;$01;0, 1
;     ;;;;;;;;;;$02;1, 1
;     ;;;;;;Effacer;Regles du jeu;;;$04;2, 1
;     ;;;;;;;;;;$08;3, 1
;     ;;;;;;;;;;$10;4, 1
;     ;;;;;;{haut};\ /;;;$20;5, 1
;     ;;;;;;ENTER;{gauche};;;$40;6, 1
;     ;;;;;;{droite};%;;;$80;7, 1
;     ;Valeur lue de $12;$80;$40;$20;$10;$08;$04;$02;$01;;
;     ;;;;;;;;;;Valeur de $12;
;     ;;:;.;B;C;X;Joueur 1;;;$01;8, 0
;     ;;AIDE;";";N;v;ESPACE;Réponse;;;$02;9, 0
;     ;;;;;;;;;;$04;
;     ;;;;;;;;;;$08;
;     ;;CDROM b0;CDROM b1;CDROM b2;;;;;;$10;
;     ;;;;;;;;;;$20;
;     ;;;;;;;;;;$40;
;     ;;;;;;;;;;$80;
;     ;Valeur lue de $10;$80;$40;$20;$10;$08;$04;$02;$01;(avec $11=0);
;     ;;;;;;;;;;Valeur de $12;
;     ;;;;;;{bas};+/=;;;$01;8, 1
;     ;;;;;;Joueur 2;;;;$02;9, 1
;     ;;;;;;;;;;$04;
;     ;;;;;;;;;;$08;
;     ;;;;;;;;;;$10;
;     ;;;;;;;;;;$20;
;     ;;;;;;;;;;$40;
;     ;;;;;;;;;;$80;
;     ;Valeur lue de $12;$80;$40;$20;$10;$08;$04;$02;$01;(avec $11=0);
; TODO : END OF FILE
          

       Default:
         
     EndSelect 
    ; Revoie $38 pour une interruption à 38h
    ; Revoie $66 pour une interruption à 66h
    ; Revoie $FFFF pour AUCUNE interruption
    ; Revoie $FFFE pour quitter la simulation
    
     ;R_CheckInterrupt=$FFFF
     If RequestPowerOff=1 
       R_CheckInterrupt=2 ; Request PowerOff
     EndIf
    ;BeforeTRAP="TRACE:AF=$"+RSet(Hex(AF, #PB_Word),4,"0")+" BC=$"+RSet(Hex(BC, #PB_Word),4,"0")+" DE=$"+RSet(Hex(DE, #PB_Word),4,"0")+" HL=$"+RSet(Hex(HL, #PB_Word),4,"0")+" IX=$"+RSet(Hex(IX, #PB_Word),4,"0")+" IY=$"+RSet(Hex(IY, #PB_Word),4,"0")+" PC: $"+RSet(Hex(PC,#PB_Word),4,"0")+" Bank$8000: (1):$"+RSet(Hex(OUTRegs(1), #PB_Byte), 2, "0")+" (2):$"+RSet(Hex(OUTRegs(2), #PB_Byte), 2, "0")+" Bank$A000: (3):$"+RSet(Hex(OUTRegs(3), #PB_Byte), 2, "0")+" (4):$"+RSet(Hex(OUTRegs(4), #PB_Byte), 2, "0")
    ProcedureReturn R_CheckInterrupt
EndProcedure
  
; IDE Options = PureBasic 5.62 (Windows - x86)
; ExecutableFormat = Shared dll
; CursorPosition = 1373
; FirstLine = 938
; Folding = Ggp0
; EnableXP
; Executable = PBASIC.dll
; CompileSourceDirectory